//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml.dll;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//css_ref Produmex.Foundation.dll;
//css_ref Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Lino.dll;

using System;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Reflection;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Teoxane;
using Produmex.Sbo.Logex.Teoxane.Generators.BarcodeController;
using Produmex.Sbo.Logex.Teoxane.Generators.BestBeforeDateGenerators;

namespace AddUpdateScript
{
    class Program
    {
        private static string CONNECTION_STRING = "Server=localhost;CompanyDB=SBODemo_US_317;ExtraDb=PMX_SBODemo_US_317;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2005;DBCultureInfo=en-US;LicenseServer=localhost:30000";
        const string SCRIPT_ROOT = @"..\WorkflowScripts";

        static void Main(string[] args)
        {
            using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
            {
                using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
                {
                    dbConn.Open(); //Open connection to SAP
                    Console.WriteLine("Connection is open to database");

                    Console.WriteLine("Workflows");


                    //AddUpdateWorkflowScript(PmxWorkflowExecutionTypes.HOOK_FLOW, "EnterPickingQuantityHookFlow",
                    //    SCRIPT_ROOT + @"\WorkflowScript_EnterPickingQuantityHookFlow\WorkflowScript_EnterPickingQuantityHookFlow.cs", dbConn);

                    //AddUpdateWorkflowScript( PmxWorkflowExecutionTypes.SUB_FLOW, "TeoxaneSalesReturnScript",
                    //    SCRIPT_ROOT + @"\WorkflowScript_TeoxaneSalesReturnScript\WorkflowScript_TeoxaneSalesReturnScript.cs", dbConn );

					//AddUpdateWorkflowScript( PmxWorkflowExecutionTypes.SUB_FLOW, "TeoxaneProductionReceiptScript",
					//    SCRIPT_ROOT + @"\WorkflowScript_TeoxaneProductionReceiptScript\WorkflowScript_TeoxaneProductionReceiptScript.cs", dbConn);

                    Console.WriteLine("Extensions");

                    AddUpdateExtension(
                         TeoxaneBarcodeController.IDs.ExtCode,
                         "IBarcodeController - Teoxane",
                         typeof(TeoxaneBarcodeController),
                         Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IBARCODECONTROLLER,
                         dbConn
                         );


                    AddUpdateExtension(
                         TeoxaneDefaultBestBeforeDateGenerator.IDs.ExtCode,
                         "IDefaultBestBeforeDateGenerator - Teoxane",
                         typeof(TeoxaneDefaultBestBeforeDateGenerator),
                         Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IBESTBEFOREDATEGENERATOR,
                         dbConn
                         );

                    AddUpdateExtensionParameter(
                    PmxExtensionParameterCodes.BBD_PRD_GENERATOR_CHANGE_BY_USER,
                    "Can user change the date (Y,N)",
                    Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionCodes.DEFAULT_BEST_BEFORE_DATE_GENERATOR,
                    Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                    "False", dbConn );

                    AddUpdateExtensionParameter(TeoxaneDefaultBestBeforeDateGenerator.IDs.ExtParamChangeByUserDuringProduction,
                        "Can the user change the bbd number during production? (Y/N)",
                        TeoxaneDefaultBestBeforeDateGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                        "False",
                        PmxExtensionParameterCodes.BBD_GENERATOR_PRODUCTION_CHANGE_BY_USER_DURING_PROD_GENERAL, dbConn);

                    AddUpdateExtensionParameter(TeoxaneDefaultBestBeforeDateGenerator.IDs.ExtParamOnChangeSaveOnProductionOrder,
                        "Save changed bbd on production order? (Y/N)",
                        TeoxaneDefaultBestBeforeDateGenerator.IDs.ExtCode,
                        Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                        "False",
                        PmxExtensionParameterCodes.BBD_GENERATOR_PRODUCTION_SAVE_CHANGE_ON_PROD_ORDR, dbConn);


                    AddUpdateExtension(
                         TeoxaneBestBeforeDateReceptionGenerator.IDs.ExtCode,
                         "IBestBeforeDateReceptionGenerator - Teoxane",
                         typeof(TeoxaneBestBeforeDateReceptionGenerator),
                         Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IBESTBEFOREDATERECEPTIONGENERATOR,
                         dbConn
                         );


                    AddUpdateExtensionParameter(
                  TeoxaneBestBeforeDateReceptionGenerator.IDs.ExtParamChangeByUserDuringReception,
                  "Can the user change the generated best before date? (Y/N)",
                  TeoxaneBestBeforeDateReceptionGenerator.IDs.ExtCode,
                  Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
                  "True",
                  PmxExtensionParameterCodes.BBD_GENERATOR_RECEPTION_CHANGE_BY_USER_GENERAL,
                  0, dbConn );

                }

                //Complete transaction
                scope.Complete();
            }
            Console.WriteLine("Done ...");
        }


        /// <summary>
        /// Add/Update <see cref="PmxExtension"/>
        /// </summary>
        /// <param name="code">The code of the extension.</param>
        /// <param name="name">The name of the extension.</param>
        /// <param name="type">The type of the extension.</param>
        /// <param name="extensionTypeCode">The extension type code.</param>
        /// <param name="conn">The SBO connection</param>
        private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionSql conn)
        {
            PmxExtensionProvider prov = new PmxExtensionProvider(conn);
            PmxExtension extension = null;
            try
            {
                bool newBO = false;
                extension = prov.GetBO(code);
                if (extension == null)
                {
                    newBO = true;
                    extension = prov.GetNewBO();
                    extension.Code = code;
                }
                extension.Name = name;
                extension.ExtensionTypeCode = extensionTypeCode;
                extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
                if (newBO)
                {
                    prov.AddBO(extension);
                }
                else
                {
                    prov.UpdateBO(extension, false, false);
                }
            }
            finally
            {
                if (extension != null) extension.Dispose();
            }
        }

        


        /// <summary>
        /// Add/Update script workflow
        /// </summary>
        /// <param name="executionType">Type of the execution.</param>
        /// <param name="name">The name of the flow.</param>
        /// <param name="sourceFilePath">Name of the file.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
        {
            PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
            PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
            PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
            PmxWorkflowScript bo = null;
            if (workflow == null)
            {
                //add the workflow
                bo = wfscProvider.GetNewBO();
                bo.Name = name;
                wfscProvider.AddBO(bo);
            }
            else
            {
                if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
                {
                    bo = wfscProvider.GetBO(workflow.InternalKey);

                }
            }

            if (bo != null)
            {
                bo.ExecutionType = executionType;

                wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
            }



        }


        /// <summary>
        /// Add/Update <see cref="PmxExtensionParameter" />
        /// </summary>
        /// <param name="code">The code of the extension parameter.</param>
        /// <param name="name">The name of the extension parameter.</param>
        /// <param name="extensionCode">The extension code.</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="defaultValue">The default value.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, PmxDbConnectionSql sqlConn)
        {
            AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, code, sqlConn );
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtensionParameter" />
        /// </summary>
        /// <param name="code">The code of the extension parameter.</param>
        /// <param name="name">The name of the extension parameter.</param>
        /// <param name="extensionCode">The extension code.</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="defaultValue">The default value.</param>
        /// <param name="generalParameterCode">The general parameter code.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, PmxDbConnectionSql sqlConn)
        {
            AddUpdateExtensionParameter(code, name, extensionCode, convertorCode, defaultValue, generalParameterCode, 0, sqlConn);
        }

        /// <summary>
        /// Add/Update <see cref="PmxExtensionParameter" />
        /// </summary>
        /// <param name="code">The code of the extension parameter.</param>
        /// <param name="name">The name of the extension parameter.</param>
        /// <param name="extensionCode">The extension code.</param>
        /// <param name="convertorCode">The convertor code.</param>
        /// <param name="defaultValue">The default value.</param>
        /// <param name="generalParameterCode">The general parameter code.</param>
        /// <param name="sequence">The sequence.</param>
        /// <param name="sqlConn">The SQL conn.</param>
        private static void AddUpdateExtensionParameter(string code, string name, string extensionCode, string convertorCode, string defaultValue, string generalParameterCode, int sequence, PmxDbConnectionSql sqlConn)
        {
            PmxExtensionParameterProvider prov = new PmxExtensionParameterProvider(sqlConn);
            PmxExtensionParameter extParam = null;
            try
            {
                bool newBO = false;
                extParam = prov.GetBO(code);
                if (extParam == null)
                {
                    newBO = true;
                    extParam = prov.GetNewBO();
                    extParam.Code = code;
                }
                extParam.Name = name;
                extParam.ExtensionCode = extensionCode;
                extParam.ConvertorCode = convertorCode;
                extParam.GeneralParameterCode = generalParameterCode;
                extParam.DefaultValue = defaultValue;
                extParam.Sequence = sequence;
                if (newBO)
                {
                    prov.AddBO(extParam);
                }
                else
                {
                    prov.UpdateBO(extParam, false, false);
                }
            }
            finally
            {
                if (extParam != null) extParam.Dispose();
            }
        }
    }
}
